version: '2'
services:
  store:
    hostname: store
    image: ${IMAGE_TEST_STORE}
    ports:
      - '${GUNICORN_PORT_STORE}:${GUNICORN_PORT_STORE}'
    environment:
      APP_STAGE: 'utils.config.TestingConfig'
      DATABASE_URI: 'sqlite:///store.db?check_same_thread=False'
      DATABASE_TEST_URI: 'sqlite:///store_test.db?check_same_thread=False'
      GUNICORN_PORT: '${GUNICORN_PORT_STORE}'
      SQLALCHEMY_TRACK_MODIFICATIONS: '${SQLALCHEMY_TRACK_MODIFICATIONS}'
      API_CERT_LOCATION: '${STORE_API_CERT_LOCATION}'
      API_KEY_LOCATION:  '${STORE_API_KEY_LOCATION}'
      RBT_CERT_LOCATION: '${STORE_RBT_CERT_LOCATION}'
      RBT_KEY_LOCATION: '${STORE_RBT_KEY_LOCATION}'
      RABBITMQ_CA_CERT_LOCATION: '${RABBITMQ_CA_CERT_LOCATION}'
      API_CA_LOCATION: '${API_CA_LOCATION}'
      RABBITMQ_PORT_HTTPS: '${RABBITMQ_PORT_HTTPS}'
      PYTHONUNBUFFERED: 1
      RABBITMQ_IP: '${RABBITMQ_IP}'
      CONSUL_HOST: '${CONSUL_IP}'
      SERVICE_NAME: '${STORE_SERVICE_NAME}'
      SERVICE_ID: '${STORE_SERVICE_ID}'
      LOG_LEVEL: '${LOG_LEVEL}'
      HOST_IP: '${SERVICE2_IP}'
    depends_on:
      - rabbitmq
      - consul
      - haproxy
    networks:
      lb7_network:
        ipv4_address: '${SERVICE2_IP}'
    restart: on-failure

  auth:
    hostname: auth
    image: ${IMAGE_TEST_AUTH}
    ports:
      - '${GUNICORN_PORT_AUTH}:${GUNICORN_PORT_AUTH}'
    environment:
      APP_STAGE: 'utils.config.TestingConfig'
      DATABASE_URI: 'sqlite:///auth.db?check_same_thread=False'
      DATABASE_TEST_URI: 'sqlite:///auth_test.db?check_same_thread=False'
      GUNICORN_PORT: '${GUNICORN_PORT_AUTH}'
      SQLALCHEMY_TRACK_MODIFICATIONS: '${SQLALCHEMY_TRACK_MODIFICATIONS}'
      API_CERT_LOCATION: '${AUTH_API_CERT_LOCATION}'
      API_KEY_LOCATION: '${AUTH_API_KEY_LOCATION}'
      RBT_CERT_LOCATION: '${AUTH_RBT_CERT_LOCATION}'
      RBT_KEY_LOCATION: '${AUTH_RBT_KEY_LOCATION}'
      RABBITMQ_CA_CERT_LOCATION: '${RABBITMQ_CA_CERT_LOCATION}'
      API_CA_LOCATION: '${API_CA_LOCATION}'
      RABBITMQ_PORT_HTTPS: '${RABBITMQ_PORT_HTTPS}'
      PYTHONUNBUFFERED: 1
      RABBITMQ_IP: '${RABBITMQ_IP}'
      CONSUL_HOST: '${CONSUL_IP}'
      SERVICE_NAME: '${AUTH_SERVICE_NAME}'
      SERVICE_ID: '${AUTH_SERVICE_ID}'
      LOG_LEVEL: '${LOG_LEVEL}'
      HOST_IP: '${SERVICE3_IP}'
    depends_on:
      - rabbitmq
      - consul
      - haproxy
    networks:
      lb7_network:
        ipv4_address: '${SERVICE3_IP}'
    restart: on-failure

  delivery:
    hostname: delivery
    image: ${IMAGE_TEST_DELIVERY}
    ports:
      - '${GUNICORN_PORT_DELIVERY}:${GUNICORN_PORT_DELIVERY}'
    environment:
      APP_STAGE: 'utils.config.TestingConfig'
      DATABASE_URI: 'sqlite:///delivery.db?check_same_thread=False'
      DATABASE_TEST_URI: 'sqlite:///delivery_test.db?check_same_thread=False'
      GUNICORN_PORT: '${GUNICORN_PORT_DELIVERY}'
      SQLALCHEMY_TRACK_MODIFICATIONS: '${SQLALCHEMY_TRACK_MODIFICATIONS}'
      PYTHONUNBUFFERED: 1
      RABBITMQ_IP: '${RABBITMQ_IP}'
      API_CERT_LOCATION: '${DELIVERY_API_CERT_LOCATION}'
      API_KEY_LOCATION: '${DELIVERY_API_KEY_LOCATION}'
      RBT_CERT_LOCATION: '${DELIVERY_RBT_CERT_LOCATION}'
      RBT_KEY_LOCATION: '${DELIVERY_RBT_KEY_LOCATION}'
      RABBITMQ_CA_CERT_LOCATION: '${RABBITMQ_CA_CERT_LOCATION}'
      API_CA_LOCATION: '${API_CA_LOCATION}'
      RABBITMQ_PORT_HTTPS: '${RABBITMQ_PORT_HTTPS}'
      HAPROXY_IP: haproxy
      HAPROXY_PORT: '${HAPROXY_PORT}'
      CONSUL_HOST: '${CONSUL_IP}'
      SERVICE_NAME: '${DELIVERY_SERVICE_NAME}'
      SERVICE_ID: '${DELIVERY_SERVICE_ID}'
      LOG_LEVEL: '${LOG_LEVEL}'
      HOST_IP: '${SERVICE5_IP}'
    depends_on:
      - rabbitmq
      - consul
      - haproxy
    networks:
      lb7_network:
        ipv4_address: '${SERVICE5_IP}'
    restart: on-failure
  machine:
    hostname: machine
    image: ${IMAGE_TEST_MACHINE}
    ports:
      - '${GUNICORN_PORT_MACHINE}:${GUNICORN_PORT_MACHINE}'
    environment:
      APP_STAGE: 'utils.config.TestingConfig'
      GUNICORN_PORT: '${GUNICORN_PORT_MACHINE}'
      PYTHONUNBUFFERED: 1
      RABBITMQ_IP: '${RABBITMQ_IP}'
      API_CERT_LOCATION: '${MACHINE_API_CERT_LOCATION}'
      API_KEY_LOCATION: '${MACHINE_API_KEY_LOCATION}'
      RBT_CERT_LOCATION: '${MACHINE_RBT_CERT_LOCATION}'
      RBT_KEY_LOCATION: '${MACHINE_RBT_KEY_LOCATION}'
      RABBITMQ_CA_CERT_LOCATION: '${RABBITMQ_CA_CERT_LOCATION}'
      API_CA_LOCATION: '${API_CA_LOCATION}'
      RABBITMQ_PORT_HTTPS: '${RABBITMQ_PORT_HTTPS}'
      HAPROXY_IP: haproxy
      HAPROXY_PORT: '${HAPROXY_PORT}'
      CONSUL_HOST: '${CONSUL_IP}'
      SERVICE_NAME: '${MACHINE_SERVICE_NAME}'
      SERVICE_ID: '${MACHINE_SERVICE_ID}'
      LOG_LEVEL: '${LOG_LEVEL}'
      HOST_IP: '${SERVICE4_IP}'

    depends_on:
      - rabbitmq
      - consul
      - haproxy
    networks:
      lb7_network:
        ipv4_address: '${SERVICE4_IP}'
    restart: on-failure

  order:
    hostname: order
    image: ${IMAGE_TEST_ORDER}
    ports:
      - '${GUNICORN_PORT_ORDER}:${GUNICORN_PORT_ORDER}'
    environment:
      APP_STAGE: 'utils.config.TestingConfig'
      DATABASE_URI: 'sqlite:///order.db?check_same_thread=False'
      DATABASE_TEST_URI: 'sqlite:///order_test.db?check_same_thread=False'
      GUNICORN_PORT: '${GUNICORN_PORT_ORDER}'
      SQLALCHEMY_TRACK_MODIFICATIONS: '${SQLALCHEMY_TRACK_MODIFICATIONS}'
      PYTHONUNBUFFERED: 1
      RABBITMQ_IP: '${RABBITMQ_IP}'
      API_CERT_LOCATION: '${ORDER_API_CERT_LOCATION}'
      API_KEY_LOCATION: '${ORDER_API_KEY_LOCATION}'
      RBT_CERT_LOCATION: '${ORDER_RBT_CERT_LOCATION}'
      RBT_KEY_LOCATION: '${ORDER_RBT_KEY_LOCATION}'
      RABBITMQ_CA_CERT_LOCATION: '${RABBITMQ_CA_CERT_LOCATION}'
      API_CA_LOCATION: '${API_CA_LOCATION}'
      RABBITMQ_PORT_HTTPS: '${RABBITMQ_PORT_HTTPS}'
      HAPROXY_IP: haproxy
      HAPROXY_PORT: '${HAPROXY_PORT}'
      CONSUL_HOST: '${CONSUL_IP}'
      SERVICE_NAME: '${ORDER_SERVICE_NAME}'
      SERVICE_ID: '${ORDER_SERVICE_ID}'
      LOG_LEVEL: '${LOG_LEVEL}'
      HOST_IP: '${SERVICE6_IP}'
    depends_on:
      - rabbitmq
      - consul
      - haproxy
    networks:
      lb7_network:
        ipv4_address: '${SERVICE6_IP}'
    restart: on-failure

  log:
    hostname: log
    image: ${IMAGE_TEST_LOG}
    ports:
      - '${GUNICORN_PORT_LOG}:${GUNICORN_PORT_LOG}'
    environment:
      APP_STAGE: 'utils.config.TestingConfig'
      DATABASE_URI: 'sqlite:///log.db?check_same_thread=False'
      DATABASE_TEST_URI: 'sqlite:///log_test.db?check_same_thread=False'
      GUNICORN_PORT: '${GUNICORN_PORT_LOG}'
      SQLALCHEMY_TRACK_MODIFICATIONS: '${SQLALCHEMY_TRACK_MODIFICATIONS}'
      PYTHONUNBUFFERED: 1
      RABBITMQ_IP: '${RABBITMQ_IP}'
      API_CERT_LOCATION: '${LOG_API_CERT_LOCATION}'
      API_KEY_LOCATION: '${LOG_API_KEY_LOCATION}'
      RBT_CERT_LOCATION: '${LOG_RBT_CERT_LOCATION}'
      RBT_KEY_LOCATION: '${LOG_RBT_KEY_LOCATION}'
      RABBITMQ_CA_CERT_LOCATION: '${RABBITMQ_CA_CERT_LOCATION}'
      API_CA_LOCATION: '${API_CA_LOCATION}'
      RABBITMQ_PORT_HTTPS: '${RABBITMQ_PORT_HTTPS}'
      HAPROXY_IP: haproxy
      HAPROXY_PORT: '${HAPROXY_PORT}'
      CONSUL_HOST: '${CONSUL_IP}'
      SERVICE_NAME: '${LOG_SERVICE_NAME}'
      SERVICE_ID: '${LOG_SERVICE_ID}'
      LOG_LEVEL: '${LOG_LEVEL}'
      HOST_IP: '${SERVICE7_IP}'

    depends_on:
      - rabbitmq
      - consul
      - haproxy
    networks:
      lb7_network:
        ipv4_address: '${SERVICE7_IP}'
    restart: on-failure
  payment:
    hostname: payment
    image: ${IMAGE_TEST_PAYMENT}
    ports:
      - '${GUNICORN_PORT_PAYMENT}:${GUNICORN_PORT_PAYMENT}'
    environment:
      APP_STAGE: 'utils.config.TestingConfig'
      DATABASE_URI: 'sqlite:///payment.db?check_same_thread=False'
      DATABASE_TEST_URI: 'sqlite:///payment_test.db?check_same_thread=False'
      GUNICORN_PORT: '${GUNICORN_PORT_PAYMENT}'
      SQLALCHEMY_TRACK_MODIFICATIONS: '${SQLALCHEMY_TRACK_MODIFICATIONS}'
      PYTHONUNBUFFERED: 1
      RABBITMQ_IP: '${RABBITMQ_IP}'
      API_CERT_LOCATION: '${PAYMENT_API_CERT_LOCATION}'
      API_KEY_LOCATION: '${PAYMENT_API_KEY_LOCATION}'
      RBT_CERT_LOCATION: '${PAYMENT_RBT_CERT_LOCATION}'
      RBT_KEY_LOCATION: '${PAYMENT_RBT_KEY_LOCATION}'
      RABBITMQ_CA_CERT_LOCATION: '${RABBITMQ_CA_CERT_LOCATION}'
      API_CA_LOCATION: '${API_CA_LOCATION}'
      RABBITMQ_PORT_HTTPS: '${RABBITMQ_PORT_HTTPS}'
      HAPROXY_IP: haproxy
      HAPROXY_PORT: '${HAPROXY_PORT}'
      CONSUL_HOST: '${CONSUL_IP}'
      SERVICE_NAME: '${PAYMENT_SERVICE_NAME}'
      SERVICE_ID: '${PAYMENT_SERVICE_ID}'
      LOG_LEVEL: '${LOG_LEVEL}'
      HOST_IP: '${SERVICE1_IP}'

    depends_on:
      - rabbitmq
      - consul
      - haproxy
    networks:
      lb7_network:
        ipv4_address: '${SERVICE1_IP}'
    restart: on-failure

  haproxy:
    image: ${IMAGE_TEST_HAPROXY}
    volumes:
      - './ca:/usr/local/etc/haproxy/ca'
    ports:
      - '${HAPROXY_PORT}:${HAPROXY_PORT}'
      - '${HAPROXY_STATS_PORT}:${HAPROXY_STATS_PORT}'
    expose:
      - '${HAPROXY_PORT}'
      - '${HAPROXY_STATS_PORT}'
    networks:
      lb7_network:
        ipv4_address: '${HAPROXY_IP}'
    environment:
      SERVICE1_IP: '${SERVICE1_IP}'
      SERVICE1_PORT: '${GUNICORN_PORT_PAYMENT}'
      SERVICE2_IP: '${SERVICE2_IP}'
      SERVICE2_PORT: '${GUNICORN_PORT_AUTH}'
      SERVICE3_IP: '${SERVICE3_IP}'
      SERVICE3_PORT: '${GUNICORN_PORT_MACHINE}'
      SERVICE4_IP: '${SERVICE4_IP}'
      SERVICE4_PORT: '${GUNICORN_PORT_DELIVERY}'
      SERVICE5_IP: '${SERVICE5_IP}'
      SERVICE5_PORT: '${GUNICORN_PORT_ORDER}'
      SERVICE7_PORT: '${GUNICORN_PORT_LOG}'
      SERVICE7_IP: '${SERVICE7_IP}'
      HAPROXY_PORT: '${HAPROXY_PORT}'
      HAPROXY_STATS_PORT: '${HAPROXY_STATS_PORT}'
      #CONSUL_IP: '${HOST_IP}' #for AWS
      CONSUL_IP: '${CONSUL_IP}' #for DEV
      HOST_IP: '${HOST_IP}'
    restart: on-failure
  rabbitmq:
    image: ${IMAGE_TEST_RABBITMQ}
    networks:
      lb7_network:
        ipv4_address: '${RABBITMQ_IP}'
    volumes:
      - './rabbitmq:/conf'
      - './ca:/conf/ca'
    ports:
      - '5672:5672'
      - '5671:5671'
      - '15672:15672'
      - '15671:15671'
    environment:
      - 'RABBITMQ_SSL_CACERTFILE=${RABBITMQ_SSL_CACERTFILE}'
      - 'RABBITMQ_SSL_CERTFILE=${RABBITMQ_SSL_CERTFILE}'
      - 'RABBITMQ_SSL_KEYFILE=${RABBITMQ_SSL_KEYFILE}'
      - 'RABBITMQ_SSL_FAIL_IF_NO_PEER_CERT=${RABBITMQ_SSL_FAIL_IF_NO_PEER_CERT}'
      - 'RABBITMQ_SSL_VERIFY=${RABBITMQ_SSL_VERIFY}'

  consul:
    image: ${IMAGE_TEST_CONSUL}
    volumes:
      - './consul:/consul/config'
    ports:
      - '8300:8300'
      - '8301:8301'
      - '8301:8301/udp'
      - '8500:8500'
      - '8501:8501'
      - '8600:8600'
      - '8600:8600/udp'
    networks:
      lb7_network:
        ipv4_address: '${CONSUL_IP}'

networks:
  lb7_network:
    driver: bridge
    ipam:
      driver: default
      config:
        - subnet: '${NETWORK_SUBNET}'
